<?php

class dmeng_Options_Data {
  
  public $tabs;

  public function __construct() {
    
    $this->tabs = array(
      'tables' => __('数据表', 'dmeng'),
      'login' => __('最近登录', 'dmeng'),
      'tracker' => __('流量', 'dmeng'),
      'vote' => __('投票', 'dmeng'),
      'credit' => __('积分', 'dmeng'),
      'gift' => __('礼品', 'dmeng'),
      'message' => __('消息', 'dmeng')
    );

    add_filter('dmeng_options_data_page-tabs', array($this, 'add_tab'));

    foreach (array_keys($this->tabs) as $key) {
      add_action('dmeng_options_data_page_'.$key, array($this, $key.'_options'));
    }

  }

  public function add_tab($tabs) {
    $tabs = array_merge($this->tabs, $tabs);
    return $tabs;
  }
  
  public function tables_options() {

    if (!empty($_POST['data'])) {
      dmeng_options_check_nonce(__FUNCTION__);
      parse_str( $_POST['data'], $data );
      
      if (
        !empty($data['action'])
        && 'db_upgrade'==$data['action']
      ) {
        do_action('dmeng_db_upgrade');
        dmeng_flush();
        exit;
      }
      
      if (
        !empty($data['action'])
        && 'flush'==$data['action']
      ) {
        dmeng_flush();
        echo dmeng_options_notice(__('缓存清理成功', 'dmeng'));
      }

    }
  
    $output = dmeng_options_new_nonce(__FUNCTION__);

    $output .= '<h3>'.__('数据表版本更新', 'dmeng').'</h3>';
    
    if ( apply_filters('dmeng_db_upgrade_check', false) ) {

      $output .= '<p>'.__('需要更新，请先备份数据库，然后点击更新按钮并稍后。', 'dmeng').'</p>';
      $output .= '<div id="db_upgrade_reposone" style="margin:10px 0;"></div>';
      $output .= dmeng_options_form_output(
        array( 'method' => 'post', 'id' => 'db_upgrade' ),
        '<input type="hidden" name="action" value="db_upgrade" />
        <input type="hidden" name="_wpnonce" value="'.wp_create_nonce('db_upgrade').'" />
        <input class="button button-primary" type="submit" value="'.__('已备份数据库，现在更新', 'dmeng').'" />',
        false
      );
      
      ob_start();
      ?>
      <script>
      !function($){
        $('#db_upgrade').on('submit', function(){
          var $btn = $(this).find('[type=submit]');
          $btn.val('<?php _e('请稍候', 'dmeng');?>').prop('disabled', true);
          window.getDmengOptionsPostData = $(this).serialize();
          getDmengOptionsPage('', false);
          getDmengOptions.done(function(e){
            $('#db_upgrade_reposone').html(e);
            $btn.remove();
          });
          return false;
        });
      }(jQuery);
      </script>
      <br />
      <?php
      $output .= ob_get_clean();
 
    } else {
      $output .= '<p>'.__('您使用的多梦主题的数据表结构已经是最新版本。', 'dmeng').'</p>';
    }

    $output .= '<p class="description">'.__('温馨提示：使用最新代码结构可确保最少资源消耗和最佳性能。', 'dmeng').'</p>';
    
    $output .= '<h3>'.__('缓存', 'dmeng').'</h3>';
    
    $output .= dmeng_options_form_output(
      array( 'method' => 'post', 'id' => 'db_upgrade' ),
      '<input type="hidden" name="action" value="flush" />
      <input type="hidden" name="_wpnonce" value="'.wp_create_nonce('flush').'" />
      <input class="button" type="submit" value="'.__('点击清空缓存', 'dmeng').'" />',
      false
    );
    
    $output .= '<br /><p class="description">'.__('包括固定链接缓存、多梦主题 Transient 缓存以及全部内存缓存。', 'dmeng').'</p>';
    
    echo '<div class="options-box">'.$output.'</div>';
  }
  
  public function login_options() {
    echo '<div class="options-box">将在下个版本提供，敬请期待。</div>';
  }
  
  public function tracker_options() {
    echo '<div class="options-box">将在下个版本提供，敬请期待。</div>';
  }
  
  public function vote_options() {
    echo '<div class="options-box">将在下个版本提供，敬请期待。</div>';
  }
  
  public function credit_options() {
    echo '<div class="options-box">将在下个版本提供，敬请期待。</div>';
  }
  
  public function gift_options() {
    echo '<div class="options-box">将在下个版本提供，敬请期待。</div>';
  }

  public function message_options() {
    echo '<div class="options-box">将在下个版本提供，敬请期待。</div>';
  }

}

new dmeng_Options_Data;