<?php

function dmeng_options_table_build($rows) {
  
  $output = '<table class="form-table"><tbody>';

  foreach ($rows as $row) {
    
    $row = array_merge(
      array(
        'required' => false,
        'type' => '',
        'input_type' => 'text',
        'title' => '',
        'description' => '',
        'name' => '',
        'id' => '',
        'value' => '',
        'classes' => '',
        'size' => 5
      ), $row
    );
    
    $description = empty($row['description']) ? '' : '<p class="description">'.$row['description'].'</p>';

    switch($row['type']) {
      case 'input' : 

        $output .=
        '<tr>
          <th scope="row"><label for="'.$row['name'].'">'.$row['title'].'</label></th>
          <td>
            <input name="'.$row['name'].'" type="'.$row['input_type'].'" id="'.$row['id'].'" value="'.esc_attr($row['value']).'" class="regular-text ltr '.$row['classes'].'" '.($row['required'] ? 'required="required" ' : '').'> '.$description.'
          </td>
        </tr>';

        break;
      case 'textarea' : 

        $output .=
        '<tr>
          <th scope="row"><label for="'.$row['name'].'">'.$row['title'].'</label></th>
          <td>
            <fieldset>
              <legend class="screen-reader-text"><span>'.$row['title'].'</span></legend>
              <p><textarea name="'.$row['name'].'" rows="'.$row['size'].'" cols="50" id="'.$row['id'].'" class="large-text '.$row['classes'].'" '.($row['required'] ? 'required="required" ' : '').'>'.$row['value'].'</textarea></p>
              '.$description.'
            </fieldset>
          </td>
        </tr>';
        break;
      case 'select' : 

        $options = '';
        foreach( $row['options'] as $key=>$value ){
          $options .= sprintf('<option value="%1$s"%2$s>%3$s</option>', $key, ($key==$row['value'] ? ' selected="selected"' : ''), $value);
        }

        $output .=
        '<tr>
          <th scope="row"><label for="'.$row['name'].'">'.$row['title'].'</label></th>
          <td>
            <select name="'.$row['name'].'" id="'.$row['id'].'">'.$options.'</select>
            '.$description.'
          </td>
        </tr>';
        
        break;
      case 'checkbox' : 
      
        $options = '';
        foreach( $row['options'] as $key=>$value ){
          $options .= sprintf('<label><input name="%1$s[]" type="checkbox" value="%2$s"%3$s> %4$s </label> ', $row['name'], $key, (in_array($key, (array)$row['value']) ? ' checked' : ''), $value);
        }
        
        $output .=
        '<tr>
          <th scope="row"><label for="'.$row['name'].'">'.$row['title'].'</label></th>
          <td>
            <fieldset>
              <legend class="screen-reader-text"><span>'.$row['title'].'</span></legend>
              '.$options.'
            </fieldset>
            '.$description.'
          </td>
        </tr>';
        break;
      default :
      
        $output .=
        '<tr>
          <th scope="row"><label for="'.$row['name'].'">'.$row['title'].'</label></th>
          <td>
            '.$row['value'].$description.'
          </td>
        </tr>';

    }
  }

  $output .= '</tbody></table>';
  
  return $output;
}

function dmeng_options_form_output($attr=array(), $fields='', $submit_button=true) {

  $submit_button = $submit_button ? '<p class="submit"><input type="submit" name="submit" id="submit" class="button button-primary" value="'.__('保存更改', 'dmeng').'"></p>' : '';

  $output = '<form ';

  foreach ($attr as $name=>$value) {
    $output .= $name.'="'.esc_attr($value).'" ';
  }

  $output .= '>'.$fields.$submit_button.'</form>';

  return $output;
}

function dmeng_options_notice($notice='', $success=true) {
  $notice = !empty($notice) ? $notice : ( $success ? __('更新成功') : __('更新出错') );
  return '<div id="dmeng-options-notice" '.($success ? '' : 'class="error"').'>'.$notice.'</div>';
}

function dmeng_options_new_nonce($action) {
  return '<script>var dop_nonce = "'.wp_create_nonce($action).'";</script>';
}

function dmeng_options_check_nonce($action) {
  if (empty($_POST['_wpnonce']) || false===wp_verify_nonce($_POST['_wpnonce'], $action)) {
    echo dmeng_options_notice(
      __('你确定这样做？', 'dmeng').
      dmeng_options_new_nonce($action).
      '<br /><p><a class="button" href="javascript:getDmengOptionsPage();">'.__('重试', 'dmeng').'</a></p>', 
    false);
    die();
  }
}

require dirname(__FILE__).'/options.class.php';
require dirname(__FILE__).'/options-default.php';
require dirname(__FILE__).'/options-shortcode.php';
require dirname(__FILE__).'/options-data.php';