<?php

class dmeng_CodePrettify {
  
  public function __construct() {
    //add_filter( 'the_content', array( $this, 'auto_linenums' ), 1 );
    add_filter( 'dmeng_scripts_args', array( $this, 'output_script_uri' ) );
    add_filter( 'dmeng_scripts_args', array( $this, 'output_style_url' ) );
    add_filter( 'dmeng_scripts_args', array( $this, 'output_linenum_url' ) );
  }
  
  public function auto_linenums($content) {
    return preg_replace_callback(
            '/(<code[^>]*>)(.*?)<\/code>/is',
            array($this, 'auto_linenums_callback'), 
            $content
           );
  }

  public function auto_linenums_callback($matches) {
    if (strpos($matches[2], PHP_EOL) || strpos($matches[2], "\n"))
      $matches[1] = '<code data-linenums="true"'.ltrim($matches[1], '<code');

    return $matches[1].esc_html($matches[2]).'</code>';
  }

    public function output_script_uri($args)
    {
        if (get_option('dmeng_google_code_prettify') == 1){
        if (empty($args['cpfuri']))
            $args['cpfuri'] = apply_filters('dmeng_codeprettify_uri', get_template_directory_uri() . '/highlight/highlight.pack.js');
            return $args;
        }
        return;
    }

    public function output_style_url($args)
    {
        if (empty($args['hlcss']))
            $args['hlcss'] = apply_filters('dmeng_hljsstyle_uri', get_template_directory_uri() . '/highlight/default.css');
        return $args;
    }

    public function output_linenum_url($args)
    {
        if (empty($args['hlln']))
            $args['hlln'] = apply_filters('dmeng_hljslinenumber_uri', get_template_directory_uri() . '/highlight/highlightjs-line-numbers.min.js');
        return $args;
    }

}

$dmeng_CodePrettify = new dmeng_CodePrettify;